// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include <wl.h>
#include <ilu.h>
#include <GL/glu.h>
#include <stdlib.h>

void
uInit()
{
	glClearColor(0, 0, 0.5, 0);
}

void
spinUpdate(float *spin)
{
	*spin += 2;
	if(*spin > 360) *spin -= 360;
}

void
uDraw(void *data)
{
	float *spin = data;
	spinUpdate(spin);
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();
	glRotatef(*spin, 0, 0, 1);
	glBegin(GL_POLYGON);
		glVertex2f(-0.5, -0.5);
		glVertex2f(-0.5,  0.5);
		glVertex2f( 0.5,  0.5);
		glVertex2f( 0.5, -0.5);
	glEnd();
}

void
uReshape(int width, int height, void *data)
{
	glViewport(0, 0, width, height);
}

int
main(int argc, char *argv[])
{
	float spin = 0;
	ilOpen(IL_KEYBOARD_BIT);
	wlDrawFunc(uDraw, &spin);
	wlReshapeFunc(uReshape, NULL);
	wlCreate("FreeWL window", 640, 480);
	uInit();
	ILboolean loop = IL_TRUE;
	while(loop)
	{
		wlUpdate();
		wlSwapBuffers();
		ilRead(IL_KEYBOARD_BIT);
		if(ilEvent(IL_KEYBOARD_BIT))
		{
			ILevent event;
			ilGetEvent(IL_KEYBOARD_BIT, &event);
			if(wlHasFocus() && iluIsEvent(event, IL_EVENT_TYPE_KEY, IL_EVENT_CODE_KEY_ESC, 1))
				loop = IL_FALSE;
		}
	}
	wlDestroy();
	ilClose(IL_KEYBOARD_BIT);
	return EXIT_SUCCESS;
}
