// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _FWL_H_
#define _FWL_H_

typedef enum {
	WL_FOCUS_BIT = 1,
} WLenum;

typedef enum { WL_TRUE = 1, WL_FALSE = !WL_TRUE } WLboolean;
typedef double WLdouble;
typedef float WLfloat;
typedef int WLint;
typedef unsigned int WLuint;
typedef int WLsizei;
typedef void WLvoid;

void
wlCreate(const char *title, WLsizei width, WLsizei height);

void
wlDestroy();

void
wlSwapBuffers();

void
wlDrawFunc(void (*uDraw)(void *), void *data);

void
wlReshapeFunc(void (*uReshape)(WLsizei, WLsizei, void *), void *data);

void
wlUpdate();

void
wlGrabPointer();

void
wlUngrabPointer();

WLboolean
wlHasFocus();

void
wlGetBooleanv(WLenum pname, WLboolean *params);

void
wlGetDoublev(WLenum pname, WLdouble *params);

void
wlGetFloatv(WLenum pname, WLfloat *params);

void
wlGetIntegerv(WLenum pname, WLint *params);

#endif

